void test() {     //Generate test signal
  while (1){
    PORTB &= 0xee;  // sends a ground to the SCR gate
    delay_us(56);   // 56 us delay
    PORTB |= 0x11;   // ground off the SCR
    if (PORTB & 0x04) delay_ms(200); //300 rpm
    else delay_ms(8); //7500 RPM
  }
}

void main() {
onst char tspark[]={ 0,  0,  0,  1,  1,  1,  1,  2,  2,  2,  2,  3,  3,  3,  4,  4,  4,  4,  5,  5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  8,  8,  8,  8,  9,  9,  9,  9,  10,  10,  10,  10,  11,  11,  11,  12,  12,  12,  12,  13,  13,  13,  13,  14,  14,  14,  14,  15,  15,  15,  16,  16,  16,  16,  17,  17,  17,  17,  18,  18,  18,  18,  19,  19,  19,  20,  20,  20,  20,  21,  21,  21,  23,  23,  26,  26,  28,  28,  31,  31,  32,  34,  34,  35,  37,  38,  38,  40,  41,  41,  44,  44,  45,  48,  48,  51,  51,  54,  55,  58,  58,  61,  62,  65,  65,  69,  69,  72,  73,  74,  77,  77,  78,  81,  82,  83,  84,  87,  88,  88,  89,  93,  93,  94,  95,  96,  96,  97,
      98,  98,  102,  103,  104,  104,  105,  106,  107,  107,  108,  109,  110,  110,  111,  112,  112,  113,  117,  118,  119,  120,  120,  121,  122,  123,  123,  124,  125,  126,  126,  127,  132,  133,  133,  134,  135,  136,  136,  137,  138,  139,  140,  140,  141,  142,  143,  143,  144,  145,  146,  146,  147,  152,  153,  154,  155,  156,  156,  157,  158,  159,  160,  160,  161,  162,  163,  163,  164,  165,  166,  167,  168,  168,  169,  170,  171,  172,  172,  173,  174,  175,  176,  176,  177,  178,  179,  180,  180,  181,  182,  183,  183,  184,  185,  186,  187,  188,  188,  189,  190,  191,  192,  192,  193,  194,  195,  196,  196,  197,  198,  199,  200,  200,  201,  202,  203,  203,  204};
  short int spark=0;
  unsigned int tspk, t0,t1,low;
  unsigned int ofc; //Holds number of overflows

  const unsigned int LowDelay=25;   //Delay <1832 RPM, in degrees

  const unsigned int ld=360/LowDelay; //Dont change this
  TRISB = 0x0E;      // set RB1,2,3 for input, all others for output RB0=SCR RB4=Strobe
  PORTB = 0x11;      // set gate to SCR high i.e pin 6 of PIC +strobe
  OPTION_REG = 0x06; // tmr0 SOURCE INT CLOCK, 1:128 PRESCALER
  INTCON = 0x00;     //Disable interrupts +Resets interrupt flags
  TMR2 = 0;          //Reset timer2
  TMR0 = 0;          //Reser timer0
  PR2 = 255;         //This is how far timer2 counts before overflow
  T2CON = 0x07;      // start TMR2 counter 1:16

  if (PORTB.F3) test(); //If test jumper is on jump to test function

  while(1){           //Loop forever
    ofc=0;            //Reset overflow counter
    INTCON = 0x00;    //Disable interrupts +Resets interrupt flags
    while(PORTB & 0x02){ //Wait for low pulse on Hall switch
      if  (INTCON&4) {    //Overflow
        ofc++;            //Increase overflow counter
        INTCON = 0x00;    //Resets interrupt flags
      }
      spark = 1;
    }                    //North pole of magnet has passed
    if(spark){
      t0 = TMR0;
      TMR0 = 0;          //Start new rev count
      if(ofc > 0) {      //Overflow timer0, we have < 1832 RPM
        if ( ofc >= 36) ofc=36; //Min RPM 50 to avoid big calculations
        low=ofc*ld;       //Simplified calculation, gives about 25 degrees
        delay_cyc (low);  //extra delay based on overflow counter
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);    //Repeat 16 times - prescaler
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        delay_cyc (low);
        }                   //max255 -> 2550 cycles
      tspk = tspark[t0]; //use table lookup for spark delay
      T2CON = 0x07;      //start TMR2 counter 1:16
      TMR2= 0;           //clear spark timer
      while(TMR2 < tspk);//loop until timeout to send spark
      PORTB &= 0xee;     //sends a ground to the SCR gate
      delay_us(56);      //56 us delay
      PORTB |= 0x11;     //ground off the SCR
      spark = 0;
  } //if(spark)
} //while(1)
} //main

////////////////////////////////////////////////////////////////////
//Notes
//
// ; At a engine speed of 1200 RPM;
// ;
// ; 1200 / 60 = 20 revs per second
// ; 1 / 20 = 50mS per rev
// ; 1 rev = 360 degrees
// ;
// ; 36 degrees at 1200 RPM = (36 / 360) X 50 = 5mS
// ;
// ; 100uS loop time
// ; 4MHz clock / 4 = 1MHz instruction cycle
// ; cycle time = 1/1MHz = 100uS
// ; 100uS/100uS = 100 cycles
// ; prescaler set to divide by 4
// ; preset TMR0 = 231, when = 0 = 100uS
// ; 231 to 255 = 25 x 4(prescaler) = 100


//                          ---O---
//                      RA2 o     o RA1
//                      RA3 o     o RA0
//                      RA4 o     o RA7
//                      RA5 o     o RA6
//                      VSS o     o VDD
//                  SCR RB0 o     o RB7
//  Hall input USART RX RB1 o     o RB6
// Test hi/low USART TX RB2 o     o RB5
//          Test on/off RB3 o     o RB4 Strobelight
//                          -------

//History:
//1.0  1832fix not working

